<?php

    ini_set('memory_limit', '1024M');
    set_time_limit(0);
    ini_set('max_execution_time', 7200);
    ini_set('display_errors', 1);
    ini_set("log_errors", 1);
    ini_set("error_log", "mls_import.txt");

    error_reporting(E_ALL);
    date_default_timezone_set('America/Toronto');
    echo "<pre>";

    $mtime   = microtime();
    $mtime   = explode(" ", $mtime);
    $mtime   = $mtime[1] + $mtime[0];
    $t_start = $mtime;
    
    require_once("config/db_config.php");
    require_once("config/properties_config.php");
    require_once("config/mls_config.php");
    require_once('library/vendor/MysqliDb.php');
    require_once("library/phrets.php");
    
    $dbcron      = new MysqliDb($servername, $db_username, $db_password, $dbname);
    $dbproperty  = new MysqliDb($servername, $db_username, $db_password, $dbname);
    
    $timestamp_field = 'Timestamp_sql'; 
    $file_name       = "mls_import.php";
    $curr_resource   = "Property";
    $mls_key_field   = "Ml_num";
    $curr_mls_id     = 1;
    $curr_date          = date('Y-m-d H:i:s');
    $cron_tablename     = 'properties_cron_log';
    $tmp_tablename      = 'property_queue';
    echo "<pre>";
    foreach($all_classes as $classkey=> $classdata ) {
        $className = $classdata['ClassName'];
        $pro_table = $classdata['TableName'];
        //************* Step 1 *************/
        $cron_data = array(
                'cron_file_name' => $file_name,
                'cron_start_time' => $curr_date,
                'property_class' => $className,
                'mls_no' => $curr_mls_id,
                'steps_completed' => 1
            );
        $curr_log_id = $dbcron->insert($cron_tablename, $cron_data);
        $start_pull = false;
        $last_success_query = "SELECT * FROM $cron_tablename where cron_file_name='" . $file_name . "' and property_class='" . $className . "' and mls_no ='" . $curr_mls_id . "' and success = 1 and cron_end_time<> '0000-00-00 00:00:00' and properties_download_end_time<>'0000-00-00 00:00:00' ORDER BY id DESC LIMIT 1 ";
        $last_cron_data     = $dbcron->rawQuery($last_success_query);
        if (count($last_cron_data) > 0) {
            $last_success_cron_end_time = $last_cron_data[0]['properties_download_end_time'];
            if ($last_success_cron_end_time == '' || $last_success_cron_end_time == '0000-00-00 00:00:00' || $last_success_cron_end_time == '0000-00-00') {
                $property_query_start_time = strtotime($start_pull_time, time());
                $property_query_start_time = date("Y-m-d H:i:s", $property_query_start_time);
            } else {
                $property_query_start_time = $last_success_cron_end_time;
            }
        } else {
            $default_date   = "2020-05-01T00:00:01";
            $start_pull     = true;
            $property_query_start_time = $default_date ;
        }
        
        $date_time                 = explode(' ', $property_query_start_time);
        $property_query_start_time = $date_time[0] . 'T' . $date_time[1];
        $date_query                = "($timestamp_field=$property_query_start_time+)";
        $status_query   = "(Status=A)";//U,A
    
        $curr_timestamp            = time();
        $old_timestamp             = strtotime($property_query_start_time);
        $diff                      = ($curr_timestamp - $old_timestamp);
        $new_starttime             = 0;
        if ($diff > 3600 * 24 * 2) {
            $new_starttime = strtotime("+2 days", $old_timestamp);
        }
        if ($new_starttime > 0 && $new_starttime < time()) {
            $time_range1       = $property_query_start_time;
            $time_range2       = date('Y-m-d H:i:s', $new_starttime);
            $date_time2        = explode(' ', $time_range2);
            $datetime_range2   = $date_time2[0] . 'T' . $date_time2[1];
            $date_query        = "($timestamp_field=$time_range1-$datetime_range2)";
            $property_end_time = $time_range2;
        } else {
            $property_end_time = $curr_date;
            $date_query        = "($timestamp_field=$property_query_start_time+)";
        }
        
        //$date_query = "($timestamp_field=2020-04-25T00:00:01-2020-05-05T16:00:01)";
        //$date_query = "($timestamp_field=2020-05-13T00:00:01+)";
        $rets_query = "$date_query,$status_query";
        $rets_query = "$status_query";//,$sale_query";
        //$rets_query = "($mls_key_field=|C4658928)"; //COMM
        //$rets_query = "($mls_key_field=|X5438715)"; //CONDO
        echo $rets_query;
        //continue;
        
        $cron_update_data = array(
              'properties_download_start_time' => $property_query_start_time,
              'steps_completed' => 2,
              'rets_query' => $rets_query
            );
        $dbcron->where('id', $curr_log_id);
        $step2 = $dbcron->update($cron_tablename, $cron_update_data);   
        
        $property_data_mapping = $property_mapping[ $classkey ];
        $common_mapping2 =  $common_mapping[ $classkey ];
        
        $rets = new phRETS;
        $rets->AddHeader("Accept", "*/*");
        $rets->AddHeader("RETS-Version", "RETS/$rets_version");
        $rets->AddHeader("User-Agent", 'UserAgent/1.0');
        $rets->SetParam('debug_mode', false);
        $rets->SetParam("offset_support", false);
        $rets->SetParam("compression_enabled", true);
        $connect = $rets->Connect($login_url, $username, $password);
        if (!$connect) {
            $error_details = $rets->Error();
            $error_text    = strip_tags($error_details['text']);
            $error_type    = strtoupper($error_details['type']);
            echo "<center><span style='color:red;font-weight:bold;'>{$error_type} ({$error_details['code']}) {$error_text}</span></center>";
            exit;
        }
    
        $search    = $rets->SearchQuery($curr_resource, $className, $rets_query, array(
              'Count' => 2
            ));
        $total_property_count = $rets->TotalRecordsFound($search);
        echo " $className - $rets_query : $total_property_count  <br>";
        //exit;
        //continue;
        $cron_update_data3 = array(
                'properties_count_from_mls' => $total_property_count,
                'steps_completed' => 3
            );
        $dbcron->where('id', $curr_log_id);
        $step3 = $dbcron->update($cron_tablename, $cron_update_data3);
        error_log(" $className - $rets_query : $total_property_count  <br>");
    
        $inserted_prop             = 0;
        $updated_prop              = 0;
        $property_deleted   = 0;
        $properties_inserted_in_db = 0;
        if ($total_property_count > 0) {
            $search_chunks = $rets->SearchQuery("Property", $className, $rets_query, array(
                    //'Limit' => $limit,
                    //'Offset' => $offset,
                    'Format' => 'COMPACT-DECODED',
                    'Count' => 1,
                    "UsePost" => 1
                ));
            echo "FOUND" . $rets->NumRows($search_chunks);
            $all_arr = array();
            while ($record = $rets->FetchRow($search_chunks)) {
                $properties_inserted_in_db++;
                //print_r($record);
                //exit;
                echo "<br>".$listing_key = $record[ $mls_key_field ];
                //continue;
                $ci_p        = date('Y-m-d H:i:s');
                
                $property_data = array();
                $rpd_data = array();
                $trim = array('Cd',
                        'Cndsold_xd',
                        'Dt_sus',
                        'Dt_ter',
                        'Timestamp_sql',
                        'Td',
                        'Oh_date',
                        'Pix_updt',
                        'Unavail_dt',
                        'Vtour_updt',
                        'Xdtd',
                        'Oh_date1',
                        'Oh_date2',
                        'Oh_date3',
                        'Oh_dt_stamp',
                        'Condo_corp',
                        'Input_date',
                        'Ld',
                        'Unavail_dt'
                        );
                        
                $date_array = array('Vtour_updt');
                foreach( $property_data_mapping as $db_key=>$mls_key ){
                    if( isset($record[ $mls_key ]) ){
                        if( in_array($mls_key,$trim)){
                            if( $record[ $mls_key ]==''){
                                $property_data[ $db_key ] = NULL;
                            } else {
                                $property_data[ $db_key ] = rtrim($record[ $mls_key ],'.0');
                            }
                        } else {
                            $property_data[ $db_key ] = $record[ $mls_key ];
                        }
                    }
                }

                $rooms = array();
                foreach( $room_mapping as $db_key=>$mls_key ){
                    if( isset($record[ $mls_key ]) ){
                        $rooms[ $db_key ] = $record[ $mls_key ];
                    }
                }
                $rooms_data = serialize($rooms);
                
                $property_data['mls_no'] = $curr_mls_id;
                $property_data['property_last_updated'] = date('Y-m-d H:i:s');
                
                $curr_opr = '';
                $del = "";
                if( $record['Status']=='U'){
                    $property_deleted++;
                    $del_query = "DELETE FROM $pro_table where $mls_key_field='$listing_key' ";
                    $up = $dbproperty->rawQuery($del_query);
                    $selec = "SELECT * FROM  $image_table_name where L_ListingID = '$listing_key'" ;
                    $selec_result = $dbcron->rawQuery($selec);
                    if( count($selec_result)>0 ){
                        foreach ($selec_result as $sel_image) {
                            echo "<br>".$image_path = $sel_image['image_path'];
                            @unlink($image_path); // Delete old images
                        }
                    }
                    $del_im = "DELETE FROM  $image_table_name where L_ListingID = '$listing_key'" ;
                    $delm_result = $dbcron->rawQuery($del_im);
                    continue;
                    $del = " (Deleted)";
                    $pro_table_temp = $pro_table.'_sold';
                } else {
                    $pro_table_temp = $pro_table;
                }
                //print_r($property_data);
                //exit;
                // Add this id in a Temp Table
                $last_tmp_data     = $dbproperty->rawQuery("SELECT id FROM $pro_table_temp where $mls_key_field='$listing_key'");
                if (count($last_tmp_data) > 0) {
                    $prp_id = $last_tmp_data[0]['id'];
                    $curr_opr = 'U';
                    $updated_prop++;
                    echo " : Updated";
                    $dbproperty->where("$mls_key_field", $record[$mls_key_field]);
                    $updated_data = $dbproperty->update($pro_table_temp, $property_data);
                    $errorp = $dbproperty->getLastError();
                    if(!empty($errorp)){
                        print_r($errorp);
                        exit;
                    }
                    
                    /*$query = 'UPDATE '.$pro_table_temp.' SET ';
                    $fields = '';
                    $values = '';
                    foreach($property_data as $prp_key=>$prp_value){
                        $fields .= ' '.$prp_key.' ="'.esc_sql(stripslashes($prp_value)).'", ';
                    }
                    $fields = rtrim($fields,', ');
                    $currquery = $query.$fields.' WHERE '.$mls_key_field.' = "'.$record[$mls_key_field].'"';*/
                } else {
                    $curr_opr = 'I';
                    $inserted_prop++;
                    echo " : Inserted";
                    $property_data['property_insert_time'] = date('Y-m-d H:i:s');
                    $dbproperty->insert($pro_table_temp, $property_data);
                    $errorp = $dbproperty->getLastError();
                    if(!empty($errorp)){
                        print_r($errorp);
                        exit;
                    }
                    
                    /*$query = 'INSERT INTO '.$pro_table_temp.' (';
                    $values = '';
                    $fields = '';
                    foreach($property_data as $prp_key=>$prp_value){
                        $fields .= " $prp_key ,";
                        $values .= ' "'.(stripslashes($prp_value)).'",';
                    }
                    $fields = rtrim($fields,',');
                    $values = rtrim($values,',');
                    $currquery = $query.$fields.') VALUES('.$values.')';
                    echo "<br>".$currquery;
                    $dbproperty->rawQuery($currquery);
                    $errorp = $dbproperty->getLastError();
                    if(!empty($errorp)){
                        print_r($errorp);
                        exit;
                    }*/
                    
                }
                
                $rpd_data['rooms_data'] = $rooms_data; 
                foreach( $common_mapping2 as $db_key=>$mls_key ){
                    if( isset($record[ $mls_key ]) ){
                        if( in_array($mls_key,$trim)){
                            if( $record[ $mls_key ]==''){
                                $rpd_data[ $db_key ] = NULL;
                            } else {
                                $rpd_data[ $db_key ] = rtrim($record[ $mls_key ],'.0');
                            }
                        } else {
                            $rpd_data[ $db_key ] = $record[ $mls_key ];
                        }
                    }
                }
                
                $address = '';
                $address .= isset($record['St_num'])?$record['St_num'].' ' :'';
                $address .= isset($record['St_dir'])?$record['St_dir'].' ' :'';
                $address .= isset($record['St'])?$record['St'].' ' :'';
                $address .= isset($record['St_sfx'])?$record['St_sfx'].' ' :'';
                $address .= isset($record['Apt_num'])?$record['Apt_num'].' ' :'';
                $full_address = $address ;
                $full_address .= isset($record['Municipality'])?$record['Municipality'].' ':'';
                $full_address .= isset($record['County'])?$record['County'].' ':'';
                $full_address .= isset($record['Zip'])?$record['Zip'].' ':'';
                
                if($classkey=='RES'){
                    $classType = 'Residential';
                } else if($classkey=='CND'){
                    $classType = 'Condos';
                } else {
                    $classType = 'Commercial';
                }
                $address = preg_replace('/\s+/',' ',$address);
                $address = preg_replace('/\,/','',$address);
                
                $full_address = preg_replace('/\s+/',' ',$full_address);
                $full_address = preg_replace('/\,/','',$full_address);
                
                $full_address  = trim($address).', ' .$record['Municipality']. ' '.$record['County'].' '.$record['Zip'] .' '. $record['Ml_num'];
                $title = $address.'-'.$record['Municipality'].'-'.$record['County'].'-' .$record['Zip'].'-'.$record['Ml_num'];
                $title  = preg_replace('/\s+/', ' ', $title);
                $title  = trim($title);
                $title  = str_ireplace("-", " ", $title) ;
                $title  = preg_replace('/\s+/', ' ', $title); 
                $tags    = strip_tags($title);
                $tags    = preg_replace('/\s+/', '-', $tags);
                $tags    = preg_replace('/\-+/', '-', $tags);
                $vowels   = array(" ", ",", ".","#");
                $filtered = str_replace($vowels, "-", $tags);
                $filtered = preg_replace('/\-+/', '-', $filtered);
                
                $rpd_data['FilteredAddress'] = $address;
                $rpd_data['full_address'] = $full_address;
                $rpd_data['slug_url'] = $filtered;
                $rpd_data['ClassType'] = $classType;
                $rpd_data['cityname_formatted'] = trim($record['Municipality']);
                $rpd_data['mls_no'] = $curr_mls_id;
                $rpd_data['property_last_updated'] = date('Y-m-d H:i:s');
                $rpd_table = 'rets_property_data';
                $last_tmp_data     = $dbproperty->rawQuery("SELECT id FROM $rpd_table where $mls_key_field='$listing_key'");
                
                //print_r($rpd_data);
                //exit;
                
                if (count($last_tmp_data) > 0) {
                    $prp_id = $last_tmp_data[0]['id'];
                    $curr_opr = 'U';
                    $updated_prop++;
                    echo " : Updated RPD";
                    $dbproperty->where("$mls_key_field", $record[$mls_key_field]);
                    $updated_data = $dbproperty->update($rpd_table, $rpd_data);
                    $errorp = $dbproperty->getLastError();
                    if(!empty($errorp)){
                        print_r($errorp);
                        exit;
                    }
                } else {
                    $curr_opr = 'I';
                    $inserted_prop++;
                    echo " : Inserted RPD";
                    $property_data['property_insert_time'] = date('Y-m-d H:i:s');
                    $dbproperty->insert($rpd_table, $rpd_data);
                    $errorp = $dbproperty->getLastError();
                    if(!empty($errorp)){
                        print_r($errorp);
                        exit;
                    }
                }
            }
        }
    
        $cron_update_data4 = array(
            'cron_end_time' => date('Y-m-d H:i:s'),
            'steps_completed' => 4,
            'success' => 1,
            'property_inserted' => $inserted_prop,
            'property_deleted' => $property_deleted,
            'property_updated' => $updated_prop,
            'properties_download_end_time' => $property_end_time,
            'properties_count_actual_downloaded' => $properties_inserted_in_db         
        );
        $dbcron->where('id', $curr_log_id);
        $step4 = $dbcron->update($cron_tablename, $cron_update_data4);  


    }
