<?php

    ini_set('memory_limit', '1024M');
    set_time_limit(0);
    ini_set('max_execution_time', 7200);
    ini_set('display_errors', 1);
    ini_set("log_errors", 1);
    ini_set("error_log", "mls_import.txt");
    error_reporting(E_ALL);
    date_default_timezone_set('America/Toronto');
    echo "<pre>";

    require 'library/aws/vendor/autoload.php';
    use Aws\S3\S3Client;
    use Aws\S3\Exception\S3Exception;
    

    require_once("config/db_config.php");
    require_once("config/properties_config.php");
    require_once("config/mls_config.php");
    //require_once('library/vendor/MysqliDb.php');
    require_once("library/phrets.php");
    
    $dbcron      = new MysqliDb($servername, $db_username, $db_password, $dbname);
    $dbproperty  = new MysqliDb($servername, $db_username, $db_password, $dbname);
    
    $curr_mls_id     = 1;
    $curr_date          = date('Y-m-d H:i:s');
    $pic_limit  = 20;
    $dir_path   = '/home/realweb/public_html/mls/mls_images';
    
    $s3 = new S3Client([
            'version' => 'latest',
            'region'  => 'ca-central-1',
            'credentials' => [
                    'key'    => 'AKIA2TTOJYPLKCSOQX4W',
                    'secret' => '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'
                ]
    ]);
    $bucket = 'rew-images';
    
    foreach($all_classes as $classkey=> $classdata ) {
        $className = $classdata['ClassName'];
        $pro_table = $classdata['TableName'];
        $image_table_name = $pro_table.'_image';
        //************* Step 1 *************/
        
        $query   = "SELECT Ml_num ,image_download_tried from $pro_table where mls_no = $curr_mls_id and  image_download_tried < 12 and  image_downloaded = 0 LIMIT 500 ";
        $property_data     = $dbcron->rawQuery($query);
        if (count($property_data) > 0) {
            $class_path = $dir_path.'/'.$className;
            if (!is_dir($class_path))
                    mkdir($class_path, 0755, TRUE);
                
            $rets = new phRETS;
            $rets->AddHeader("Accept", "*/*");
            $rets->AddHeader("RETS-Version", "RETS/$rets_version");
            $rets->AddHeader("User-Agent", 'UserAgent/1.0');
            $rets->SetParam('debug_mode', false);
            $rets->SetParam("offset_support", false);
            $rets->SetParam("compression_enabled", true);
            $connect = $rets->Connect($login_url, $username, $password);
            if (!$connect) {
                $error_details = $rets->Error();
                $error_text    = strip_tags($error_details['text']);
                $error_type    = strtoupper($error_details['type']);
                echo "<center><span style='color:red;font-weight:bold;'>{$error_type} ({$error_details['code']}) {$error_text}</span></center>";
                exit;
            }
            
            foreach($property_data as $property){
                $sysid = $property['Ml_num'];
                echo "<br>Downloading Image for : ".$sysid;
                $full_path = $class_path.'/'.$sysid;
                //if (!is_dir($full_path))
                //    mkdir($full_path, 0755, TRUE);
                $curr_time = date("Y-m-d H:i:s");
                $photos = array();
                $photos  = $rets->GetObject( 'Property', 'Photo', $sysid);
                $pic_count    = 0;
                $images_array = array();
                if( count($photos)>0 ){
                    $selec = "SELECT * FROM  $image_table_name where L_ListingID = '$sysid'" ;
                    $selec_result = $dbcron->rawQuery($selec);
                    if( count($selec_result)>0 ){
                        foreach ($selec_result as $sel_image) {
                            echo "<br>".$image_path = $sel_image['image_path'];
                            @unlink($image_path); // Delete old images
                        }
                    }
                    $del_im = "DELETE FROM  $image_table_name where L_ListingID = '$sysid'" ;
                    $delm_result = $dbcron->rawQuery($del_im);
                    foreach ($photos as $photo) {
                        $image_data = array();
                        if ($pic_count < $pic_limit) {
                            if ($photo['Success'] == 1) {
                                $pic_count++;
                                $image_name = "Photo" . $sysid . "-" . $pic_count . ".jpeg";                    
                                $image_full_path = $full_path . "/" . $image_name;
                                /*$result = $s3->putObject([
                                        'Bucket' => $bucket,
                                        'Key'    => $keyname,
                                        'SourceFile' => $file_Path,
                                        'ACL' => ''
                                    ]);*/
                                    
                                try {
                                    $result = $s3->putObject([
                                        'Bucket' => $bucket,
                                        'Key'    => $image_name,
                                        'Body'   => $photo['Data'],
                                        'ACL'    => ''
                                    ]);
                                    if( isset( $result['ObjectURL']  ) && $result['ObjectURL'] !='' ){
                                        echo "\n".$image_url = $result['ObjectURL'];
                                        $response['image_url'] = $result['ObjectURL'] ;
                                    } else {
                                        $image_url = '';
                                        $response['status'] = false ;
                                        continue;
                                    }
                                } catch (S3Exception $e) {
                                    $error =  $e->getMessage() . PHP_EOL;
                                    echo "<br>".$error;
                                    exit;
                                    //$response['status'] = false ;
                                    //$response['error'] = $error ;
                                    //return $response; 
                                }
                                //exit;
                                //file_put_contents($image_full_path, $photo['Data']);
                                //echo "<br>".$image_full_path;
                                $image_data['image_path']        = $image_url;
                                $image_data['L_DisplayId']       = $sysid;
                                $image_data['L_ListingID']       = $sysid;
                                $property_data['mls_no']         = $curr_mls_id ;
                                $image_data['image_directory']   = $full_path ;
                                $image_data['image_name']        = $image_name;
                                $image_data['downloaded_time']   = date('Y-m-d H:i:s');
                                $image_data['sort_order_no']     = $pic_count;
                                $property_insert = $dbproperty->insert($image_table_name,$image_data);
                                
                                $errorp = $dbproperty->getLastError();
                                if(!empty($errorp)){
                                    print_r($errorp);
                                    exit;
                                }
                                
                            }
                        }
                    }
                    
                    if($pic_count>0){
                        $upquery   = "UPDATE $pro_table set  image_downloaded=1,image_download_tried=0,image_downloaded_time='$curr_time' where Ml_num = '$sysid' ";
                        $up_data   = $dbcron->rawQuery($upquery);
                    } else {
                        $upquery   = "UPDATE $pro_table set image_download_tried=image_download_tried+1 where Ml_num = '$sysid' ";
                        $up_data   = $dbcron->rawQuery($upquery);
                    }
                    
                }
            }
            
        } else {
            echo "<h2>No Listings to import images</h2>";
        }
    }