<?php

    ini_set('memory_limit', '1024M');
    set_time_limit(0);
    ini_set('max_execution_time', 7200);
    ini_set('display_errors', 1);
    ini_set("log_errors", 1);
    ini_set("error_log", "mls_import.txt");

    error_reporting(E_ALL);
    date_default_timezone_set('America/Toronto');
    echo "<pre>";

    $mtime   = microtime();
    $mtime   = explode(" ", $mtime);
    $mtime   = $mtime[1] + $mtime[0];
    $t_start = $mtime;
    
    require_once("config/db_config.php");
    require_once("config/properties_config.php");
    require_once("config/mls_config.php");
    require_once('library/vendor/MysqliDb.php');
    require_once("library/phrets.php");-
    
    $dbcron      = new MysqliDb($servername, $db_username, $db_password, $dbname);
    $dbproperty  = new MysqliDb($servername, $db_username, $db_password, $dbname);
    
    $timestamp_field = 'Timestamp_sql'; 
    $file_name       = "mls_import.php";
    $curr_resource   = "Property";
    $mls_key_field   = "Ml_num";
    $curr_mls_id     = 1;
    $curr_date          = date('Y-m-d H:i:s');
    $cron_tablename     = 'properties_cron_log';
    $tmp_tablename      = 'property_queue';
    $cc = 0;
    foreach($all_classes as $classkey=> $classdata ) {
        $cc++;
        //if($cc!=2)continue;
        $className = $classdata['ClassName'];
        $pro_table = $classdata['TableName'];
        $pro_table_temp = $pro_table.'_temp';
        $image_table_name = $pro_table.'_image';
        $pro_table_sold = $pro_table.'_sold';

        $status_query   = "(Status=A)";
        $curr_timestamp            = time();
        $new_starttime             = 0;
         $rets_query = "$status_query";
        echo $rets_query;
        //continue;
        
        $rets = new phRETS;
        $rets->AddHeader("Accept", "*/*");
        $rets->AddHeader("RETS-Version", "RETS/$rets_version");
        $rets->AddHeader("User-Agent", 'UserAgent/1.0');
        $rets->SetParam('debug_mode', false);
        $rets->SetParam("offset_support", false);
        $rets->SetParam("compression_enabled", true);
        $connect = $rets->Connect($login_url, $username, $password);//.'_a'
        if (!$connect) {
            $error_details = $rets->Error();
            $error_text    = strip_tags($error_details['text']);
            $error_type    = strtoupper($error_details['type']);
            echo "<center><span style='color:red;font-weight:bold;'>{$error_type} ({$error_details['code']}) {$error_text}</span></center>";
            exit;
        }
    
        $search    = $rets->SearchQuery($curr_resource, $className, $rets_query, array(
              'Count' => 2
            ));
        $total_property_count = $rets->TotalRecordsFound($search);
        echo " $className - $rets_query : $total_property_count  <br>";
        //exit;
        //continue;
        
        $inserted_prop             = 0;
        $updated_prop              = 0;
        $property_deleted   = 0;
        $properties_inserted_in_db = 0;
        if ($total_property_count > 0) {
            $trun = "TRUNCATE TABLE $pro_table_temp";
            $last_cron_data     = $dbcron->rawQuery($trun);
            $search_chunks = $rets->SearchQuery("Property", $className, $rets_query, array(
                    //'Limit' => $limit,
                    'Select'=>'Ml_num,Status',
                    //'Offset' => $offset,
                    'Format' => 'COMPACT-DECODED',
                    'Count' => 1,
                    "UsePost" => 1
                ));
            echo "FOUND" . $rets->NumRows($search_chunks);
            $all_arr = array();
            while ($record = $rets->FetchRow($search_chunks)) {
                $properties_inserted_in_db++;
                $listing_key = $record[ $mls_key_field ];
                $property_data = array();
                $property_data['property_inserted_time'] = date('Y-m-d H:i:s');
                $property_data['Ml_num'] = $listing_key ;
                $property_data['status'] = $record['Status'];
                $inserted_prop++;
                $dbproperty->insert($pro_table_temp, $property_data);
                $errorp = $dbproperty->getLastError();
                if(!empty($errorp)){
                    print_r($errorp);
                    exit;
                }
            }
            //$properties_inserted_in_db = 20;
            if($properties_inserted_in_db>10){
                $qu = "SELECT Ml_num FROM $pro_table  where Ml_num not in(SELECT Ml_num from $pro_table_temp )";
                $results = $dbcron->rawQuery($qu);
                if($results){
                    foreach($results as $rm_prpr){
                        $sold_data = array();
                        $sold_data['Ml_num'] =  $listing_key;
                        $sold_data['property_inserted_time'] =  date('Y-m-d H:i:s');
                        $dbproperty->insert($pro_table_sold, $sold_data);
                        
                        echo "\nRemove : ".$listing_key = $rm_prpr['Ml_num'];
                        $del_query = "DELETE FROM $pro_table where $mls_key_field='$listing_key' ";
                        $up = $dbproperty->rawQuery($del_query);
                        $selec = "SELECT * FROM  $image_table_name where L_ListingID = '$listing_key'" ;
                        $selec_result = $dbcron->rawQuery($selec);
                        if( count($selec_result)>0 ){
                            foreach ($selec_result as $sel_image) {
                                echo "<br>".$image_path = $sel_image['image_path'];
                                @unlink($image_path); // Delete old images
                            }
                        }
                        $dirname = '/home/realweb/public_html/mls/mls_images/'.$className.'/'.$listing_key;
                        if(rmdir($dirname)){
                            echo "\n Directory removed".$dirname;
                        }
                        $del_im = "DELETE FROM  $image_table_name where L_ListingID = '$listing_key'" ;
                        $delm_result = $dbcron->rawQuery($del_im);
                        
                    }
                }
            }
            //exit;
        }

    }